<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: DirTree.php,v 1.3 2000/04/25 20:40:45 kevin Exp $

global $isDirTreeDefined;
if($isDirTreeDefined)
  return;
$isDirTreeDefined = true;

// description: This class represents a directory tree
class DirTree {
  //
  // private variables
  //

  var $root;

  //
  // public methods
  //

  // description: constructor
  // param: root: the root path of the directory tree
  // returns: nothing
  function DirTree($root) {
    if(!file_exists($root))
      return null;

    $this->root = $root;
  }

  // description: gets all files under a directory tree, excluding hidden files
  // returns: an array of full paths of files, not directories, under root
  function getAllFiles() {
    $fileList = array();

    $dirQueue[0] = $this->root;
    $dirQueueCount = 1;

    while($dirQueueCount > 0) {
      $dir = $dirQueue[--$dirQueueCount];
      $handle = opendir($dir);

      while($file = readdir($handle)) {
	$fullPath = $dir."/".$file;

	// skip all dot files
	if(substr($file, 0, 1) == ".")
	  continue;

	// do not follow symlinks
	// no looping can occur
	if(is_link($fullPath))
	  continue;

	// traverse sub-directories recursively
	if(is_dir($fullPath)) {
	  $dirQueue[$dirQueueCount++] = $fullPath;
 	  continue;
	}

	$fileList[] = $fullPath;
      }
      closedir($handle);
    }

    return $fileList;
  }
}
?>
