<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: Error.php,v 1.3 2000/10/30 22:08:20 kevin Exp $

// description:
// This class represents an error.

global $isErrorDefined;
if($isErrorDefined)
  return;
$isErrorDefined = true;

class Error {
  //
  // private variables
  //

  var $message;
  var $vars;

  //
  // public methods
  //

  // description: constructor
  // param: message: an internationalizable string (i.e. can have [[domain.id]] tags)
  // param: vars: a hash of variable names to values for localizing the string
  function Error($message, $vars = array()) {
    $this->setMessage($message, $vars);
  }

  // decsription: get the error message
  // returns: an internationalizable string
  // see: setMessage()
  function getMessage() {
    return $this->message;
  }

  // description: set the error message
  // param: message: an internationalizable string (i.e. can have [[domain.id]] tags)
  // param: vars: a hash of variable names to values for localizing the string
  //     Optional
  // see: getMessage(), getVars()
  function setMessage($message, $vars = array()) {
    $this->message = $message;
    $this->vars = $vars;
  }

  // description: get the hash for string localization
  // returns: vars: a hash of variable names to values for localizing the
  //     message string. Optional
  // see: setMessage()
  function getVars() {
    return $this->vars;
  }

  // description: adding a variable to the string localization hash
  // param: key: the key of the variable in string
  // param: val: the value of the variable in string
  // see: getVars()
  function setVar($key, $val) {
    $this->vars[$key] = $val;
    return true;
  }
}
