<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: JsLibrary.php,v 1.5 2000/08/25 06:25:47 kevin Exp $

global $isJsLibraryDefined;
if($isJsLibraryDefined)
  return;
$isJsLibraryDefined = true;

include("DirTree.php");
include("System.php");

// description: this class represents a Javascript library
class JsLibrary {
  //
  // private variables
  //

  var $MAX_LINE_LEN = 10240;

  // description: searches the whole subdirectory of webDir (defined in ui.cfg)
  //     to find all the Javascript files with a all lowercase .js extension
  // param: isOptimized: make output with shorter load time
  //     Not recommended for debugging
  // returns: HTML script tags that links to all the javascript libraries
  function toHTML($isOptimized = false) {
    $system = new System();
    $webBase = $system->getConfig("webDir");

    $dirTree = new DirTree($webBase);
    $allFiles = $dirTree->getAllFiles();

    $javascriptLibs = array();
    for($i = 0; $i < count($allFiles); $i++) {
      $file = $allFiles[$i];
      $ext = substr($file, -3, 3);
      if($ext == ".js")
	$javascriptLibs[] = $file;
    }

    // sort file name (not full path) to ensure order is defined
    $nameToPath = array();
    for($i = 0; $i < count($javascriptLibs); $i++)
      $nameToPath[basename($javascriptLibs[$i])] = $javascriptLibs[$i];
    ksort($nameToPath);
    $javascriptLibs = array_values($nameToPath);

    $html = "";

    if(!$isOptimized) {
      for($i = 0; $i < count($javascriptLibs); $i++) {
        $path = substr($javascriptLibs[$i], strlen($webBase));
        $html .= "<SCRIPT LANGUAGE=\"javascript\" SRC=\"".$path."\"></SCRIPT>\n";
      }
    }
    else {
      $html .= "<SCRIPT LANGUAGE=\"javascript\">";

      for($i = 0; $i < count($javascriptLibs); $i++) {
	$handle = fopen($javascriptLibs[$i], "r");
	while(!feof($handle)) {
	  $line = fgets($handle, $this->MAX_LINE_LEN);

	  // skip whitespaces
	  $line = ltrim($line);

	  // skip comments
	  if(substr($line, 0, 2) == "//")
	    continue;

	  $html .= $line;
	}
      }

      $html .= "</SCRIPT>";
    }

    return $html;
  }
}
?>
