<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: System.php,v 1.9 2001/06/22 03:40:29 pbaltz Exp $

global $isSystemDefined;
if($isSystemDefined)
  return;
$isSystemDefined = true;

include_once("ConfigFile.php");

//
// class variables
//
// Keep these as class variables to make sure the config file is read only once
// across multiple <cough> instances... 
// actually they need to be globals, because php scoping is confused
// and these will occasionly disappear from the class scope
global $_System_configFile, $_System_expandedConfigHash, $_System_isConfigRead;
$_System_expandedConfigHash = null;
$_System_isConfigRead = false;
$_System_configFile = "/usr/sausalito/ui/conf/ui.cfg";

class System {
  //
  // public methods
  //

    // description: gets a string from the configuration file
    //     expand all the [[key]]
    //     any [[unknown key]] will be removed
    // param: key: a key string
    // returns: the expanded config
    function getConfig($key) 
    {
        global $_System_isConfigRead;
        global $_System_expandedConfigHash;
        global $_System_configFile;

        if(!$_System_isConfigRead) 
        {
            $cfg = new ConfigFile;

            if(!$cfg->readConfigFile($_System_configFile))
            {
                return "";
            }
            else 
            {
	            $_System_expandedConfigHash = $cfg->getConfig();
	            $_System_isConfigRead = true;
            }
        }

        return $_System_expandedConfigHash[$key];
    }

  // description: check if an RPM is installed
  // returns: true if installed, false otherwise
  function isRpmInstalled($rpmname) {
    $rpmResults = exec("rpm -q $rpmname 2>&1");
    if (strstr($rpmResults, "is not installed")) {
      return false;
    } else {
      return true;
    }
  }
}
?>
