<?php
// Author: Patrick Bose
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: User.php,v 1.2 2001/03/23 14:13:44 pbaltz Exp $

// This module replicates a subset of the User.pm functionality.

global $isUserDefined;
if($isUserDefined)
  return;
$isUserDefined = true;

include("CceClient.php");
include("Meta.php");

global $loginName;
global $sessionId;

// description: check the access rights of a user
// params:
//   user: - login of the user
//   access: systemAdministrator|siteAdministrator
// returns: 1|0
function user_authok( $user, $access ) {
	$cce = new CceClient();
	$cce->connect();
	$cce->auth($loginName, $sessionId);
	$cceUser = $cce->find("User", array("name" => $user, "uiRights" => $access));
	var_dump($cceUser);

	$cce->bye();
	error_log("{$cceUser[0]} $user $access");
	if ( ! $cceUser[0] ) 
		return 0;
	else
		return 1;
}

// description: tests if a user belongs to a site
// params:
//   user: username
//   group: sites group  
// returns: 0|1
function isUserInSite ( $user, $group ) {
		$userinfo = user_list_site($user);
		if ( $group == $userinfo[1] ) 
			return 1;
		return 0;
}

// description: returns the fqdn and group for a user
// params: 
//   user: username
// returns: fqdn, group of site user is associated with
function user_list_site ( $user ) {
	$obj = new Meta( array( "type" => "users" ) );
	$obj->retrieve($user);
	$group = $obj->get("vsite");

	$vobj = new Meta( array( "type" => "vsite") );
	$vobj->retrieve($group);
	$fqdn = $vobj->get("fqdn");

	return array( $fqdn, $group );
}


?>
