<?php
// Author: Patrick Bose 
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: BarGraph.php,v 1.3 2000/08/24 04:15:20 pbose Exp $

global $isBarGraphDefined;
if ( $isBarGraphDefined )
	return;
$isBarGraphDefined = true;

include("uifc/Graph.php");


class BarGraph extends Graph {

	var $ylabel;

	//
	// public methods
	//

	// constructor
	function BarGraph( $page, $data ) {
		$this->Graph( $page, $data );
	}

	function setYLabel( $label ) {
		$this->ylabel = $label;
	}

	function toHtml( $style = "" ) {
		$generatorPipe = $this->getImagePipe();
		$this->setGraphStyleOptions( $style );
		$this->setBarGraphStyleOptions( $style );
		$this->writeImageData( $generatorPipe );
		pclose( $generatorPipe );

		$filename = $this->getFilename();
		return "<TABLE><TR><TD>
	<TABLE><TR><TD WIDTH=\"50\"><CENTER>$this->ylabel</CENTER></TD><TD WIDTH=\"400\"><IMG SRC=\"$filename\"></TD></TR></TR></TABLE>
	</TD></TR><TR><TD>
	</TD></TR></TABLE>";
	}

	function getDefaultStyle( $stylist ) {
		return $stylist->getStyle("BarGraph");
	}	

	//	
	// protected methods
	//

	function setBarGraphStyleOptions( $style = "" ) {
		if ( $style == null || $style->getPropertyNumber() == 0 ) {
			$page = $this->getPage();
			$stylist = $page->getStylist();
			$style = $stylist->getStyle("BarGraph");
		}

		$barSpacing = $style->getProperty("bar_spacing");
		if ( $barSpacing ) {
			$this->setOption( "bar_spacing", $barSpacing );
		}
	}

}

?>
