<?php
// Author: Kevin K.M. Chiu
// Copyright 2001, Cobalt Networks.  All rights reserved.
// $Id: Block.php,v 1.1 2001/01/11 03:10:26 kevin Exp $

global $isBlockDefined;
if($isBlockDefined)
  return;
$isBlockDefined = true;

include("uifc/HtmlComponent.php");

// abstract
class Block extends HtmlComponent {
  //
  // private variables
  //

  var $buttons;
  var $label;
  var $width;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this block is in
  // param: label: a Label object for the block title. Optional
  function Block($page, $label = "") {
    // superclass constructor
    $this->HtmlComponent($page);

    $this->setLabel($label);

    $this->buttons = array();
    $this->width = -1;
  }

  // description: get all buttons added to the block
  // returns: an array of Button objects
  // see: addButton()
  function getButtons() {
    return $this->buttons;
  }

  // description: add a button to the block
  // param: button: a Button object
  // see: getButtons()
  function addButton($button) {
    $this->buttons[] = $button;
  }

  // description: set the width of the block
  // param: width: the width of the block in pixels 
  // see: getWidth()
  function setWidth($width) {
    $this->width = $width;
  }

  // description: get the width of the block in pixels
  // returns: the width of the block in pixels 
  // see: setWidth()
  function getWidth() {
    return $this->width;
  }

  // description: get the label of the block
  // returns: a Label object
  // see: setLabel()
  function getLabel() {
    return $this->label;
  }

  // description: set the label of the block
  // param: label: a Label object
  // see: getLabel()
  function setLabel($label) {
    $this->label = $label;
  }
}