<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: FileUpload.php,v 1.12 2001/04/13 01:55:21 kevin Exp $

global $isFileUploadDefined;
if($isFileUploadDefined)
  return;
$isFileUploadDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class FileUpload extends FormField {
  //
  // private variables
  //

  var $maxFileSize;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  // param: value: the path
  // param: maxFileSize: the maximum file size allowed to upload in bytes.
  //     Optional
  // param: invalidMessage: message to be shown upon invalid input. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function FileUpload(&$page, $id, $value, $maxFileSize = "", $invalidMessage, $emptyMessage = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, $invalidMessage, $emptyMessage);

    $this->setMaxFileSize($maxFileSize);
  }

  function getMaxFileSize() {
    return $this->maxFileSize;
  }

  // description: set the maximum file size allowed to upload
  // param: maxFileSize: bytes in integer
  function setMaxFileSize($maxFileSize) {
    $this->maxFileSize = $maxFileSize;
  }

  function toHtml($style = "") {
    $id = $this->getId();

    $builder = new FormFieldBuilder();

    // set MAX_FILE_SIZE if needed
    // this needs to be before the file input field as required by PHP
    $maxFileSize = $this->getMaxFileSize();
    //if($maxFileSize != "")
    $formField .= $builder->makeHiddenField("MAX_FILE_SIZE", $maxFileSize);

    $formField .= $builder->makeFileUploadField($id, $this->getAccess(), $GLOBALS["_FormField_width"], null, "");
    $formField .= $builder->makeJavaScript($this, "", $GLOBALS["_FormField_TextField_submit"]);

    return $formField;
  }
}
