<?php
// Author: Kevin K.M. Chiu, modified by Kenneth C.K. Leung
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: FullName.php,v 1.15 2001/04/13 01:55:21 kevin Exp $

global $isFullNameDefined;
if($isFullNameDefined)
  return;
$isFullNameDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class FullName extends FormField {
  //
  // private variables
  //

  var $lastNameFirst = true;

  //
  // public methods
  //

  function isLastNameFirst(){
    return $this->lastNameFirst;
  }

  function setLastNameFirst($lastNameFirst){
    $this->lastNameFirst = $lastNameFirst;
  }

  function toHtml($style = "") {
    $id = $this->getId();
    $value = $this->getValue();

    if($this->getAccess() == "r" && $this->isLastNameFirst())
      $value = $this->_getLastNameFirst($value);

    $builder = new FormFieldBuilder();
    $formField .= $builder->makeTextField($id, $value, $this->getAccess(), $GLOBALS["_FormField_width"], null, $GLOBALS["_FormField_change"]);
    $formField .= $builder->makeJavaScript($this, "top.code.FullName_changeHandler", $GLOBALS["_FormField_TextField_submit"]);

    return $formField;
  }

  //
  // private methods
  //

  function _getLastNameFirst($fullName){
    if(strpos($fullName,",")==false) {
      $_nameChunk = explode(" ",$fullname);
      if(count($_nameChunk) > 1) {
	$fullName = $_name_Chunk[0].", ".substr($fullName,0,(strlen($fullName) - strlen($_name_Chunk[0])));
      }
    }else{
      $_cPos = strpos($fullName,",");
      if(substr($fullName,$cPos+1,1) != " ") {
	$fullName = substr($fullName,0,$cPos)." ".substr($fullName,$cPos);
      }
    }

    return $fullName;
  }
}
