<?php
// Author: Patrick Bose 
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: Graph.php,v 1.4 2001/07/31 16:47:42 will Exp $

global $isGraphDefined;
if ( $isGraphDefined ) 
	return;
$isGraphDefined = true;

include("uifc/HtmlComponent.php");

class Graph extends HtmlComponent {

	//
	// private variables
	//
	var $options;
	var $xlabels;
	var $data;
	var $filename;

	// 
	// public methods
	//

	// description: constructor
	function Graph( $page, $data ) {
		$this->HtmlComponent( $page );
		$this->setData( $data );
	}

	function setXLabels( $xlabels ) {
		$this->xlabels = $xlabels;
	}

	function setData( $data ) {
		$this->data = $data;
	}
	
	function setFilename( $filename ) {
		$this->filename = $filename;
	}

	function getData() { return $this->data; }
	function getXLabels() { return $this->xlabels; }
	function getFilename() { return $this->filename; }

	function getDefaultStyle( $stylist ) {
		return $stylist->getStyle("Graph");
	}	

	//	
	// protected functions
	//
	
	function setOption( $name, $value ) {
		$this->options[$name] = $value;
	}
	
	function setOptions( $options ) {
		$this->options = $options;
	}

	function setGraphStyleOptions( $style = "" ) {
		if ( $style == null || $style->getPropertyNumber() == 0 ) {
			$page = $this->getPage();
#			$style = $this->getDefaultStyle( $page->getStylist() );
			$stylist = $page->getStylist();
			$style = $stylist->getStyle("Graph");
		}

		$width = $style->getProperty("width");
		$height = $style->getProperty("height");
		$shadowDepth = $style->getProperty("shadow_depth");
		if ( $shadowDepth ) {
			$this->options["shadow_depth"] = $shadowDepth;
		}
		$shadowColor = $style->getProperty("shadowclr");
		if ( $shadowColor ) {
			$this->options["shadowclr"] = $shadowColor;
		}	
		$dataColors = $style->getProperty("dclrs");
		if ( $dataColors ) {
			$this->options["dclrs"] = $dataColors;
		}

	}

	function getOptions() { return $this->options; }

	function getImagePipe() {
		$cmd = "/usr/local/bin/generateGraph.pl";
		if ( $this->filename ) { $cmd .= " -f $this->filename"; }
		$generatorPipe = popen($cmd, "w");
		return $generatorPipe;
	}

	// writes to the data file information common to all graphs
	function writeImageData( $dataFile ) {
		$options = $this->getOptions();
		if($options > 0) {
			$keys = array_keys( $options );
		} else {
			$keys = array();
		}
		for ($i=0; $i<count($keys); $i++) {
			$value = $options[$keys[$i]];
			fwrite( $dataFile, "$keys[$i] $value\n");
			next($options);
		}

		fwrite( $dataFile, "dataset ");
		$xlabels = $this->getXLabels();
		for ($i=0; $i<count($xlabels); $i++) {
			fwrite( $dataFile, $xlabels[$i] . " ");
		}

		$data = $this->getData();
		for ($i=0; $i<count($data); $i++) {
			fwrite( $dataFile, ":" );
			for ($j=0; $j<count($data[$i]); $j++) {
				fwrite( $dataFile, $data[$i][$j] . " ");
			}
		}
		fwrite( $dataFile, ":\n" );	
	}

}



?>
