<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: HtmlComponent.php,v 1.9.6.1 2001/10/18 23:05:05 pbaltz Exp $

global $isHtmlComponentDefined;
if($isHtmlComponentDefined)
  return;
$isHtmlComponentDefined = true;

include("uifc/Stylish.php");

// also implements Collatable
class HtmlComponent extends Stylish {
  //
  // private variables
  //

  var $page;
  
  // style object with which to render the component
  var $style; 
  var $styleTarget;
  
  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this HTML component is in
  function HtmlComponent(&$page) {
    $this->setPage($page);
  }

  // description: collate 2 values
  //     From the Collatable interface
  // param: valueA: the first value
  // param: valueB: the second value
  // param: collator: a Collator object
  // returns: ">" if A > B, "<" if A < B, "=" if A == B
  function collate($valueA, $valueB, $collator) {
    return $collator->collateStrings($valueA, $valueB, $collator);
  }

  // description: get the value for collation
  //     From the Collatable interface
  // returns: a value of any type
  function getCollatableValue() {
    return "";
  }

  // description: get the Page object this HTML component is in
  // returns: a Page object
  // see: setPage()
  function &getPage() {
    return $this->page;
  }

  // description: set the Page object this HTML component is in
  // param: page: a Page object
  // see: getPage()
  function setPage(&$page) {
    $this->page =& $page;
  }
  
    // Set the style object with which this component will be rendered
    // style:  a style object or style name
  function setStyle($style) {
    if(!is_object($style)) {
       $stylist = $this->page->getStylist();
       $style = $stylist->getStyle($style);
    }
    $this->style = $style;
  }
  
    // Get the style object with which this component will be rendered
  function getStyle() {
    return($this->style);
  }
  
    function setStyleTarget($target) {
        $this->styleTarget=$target;
    }
    
    function getStyleTarget() {
        return(  $this->styleTarget );
    }
    
  // Set the style based on 
 // If a style object is passed in, use it,
 // otherwise use the style class variable
 // or the default style 
  function setRightStyle($style) {  
      $page = $this->getPage();
    if(is_object($style)) {
        $this->setStyle($style);
    } else {
        if(!is_object($this->getStyle())) {
           $this->setStyle($this->getDefaultStyle($page->getStylist()));
        }
    }
  }

  // description: translate into a HTML representation
  // param: style: the style of the representation in a Style object
  // returns: HTML
  function toHtml($style = "") {
    return "";
  }
}
