<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: ImageLabel.php,v 1.11 2001/04/13 01:55:21 kevin Exp $

global $isImageLabelDefined;
if($isImageLabelDefined)
  return;
$isImageLabelDefined = true;

include("uifc/Label.php");

class ImageLabel extends Label {
  //
  // private variables
  //

  var $image;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this object lives in
  // param: image: an URL of an image
  // param: label: a label string
  // param: description: a description string
  function ImageLabel(&$page, $image, $label, $description = "") {
    // superclass constructor
    $this->Label($page->getStylist(), $label, $description);

    $this->setImage($image);
  }

  // description: get the image used as the label
  // returns: an URL of an image
  function getImage() {
    return $this->image;
  }

  // description: set the image used as the label
  // param: image: an URL of an image
  function setImage($image) {
    $this->image = $image;
  }

  function toHtml($style = "") {
    $image = $this->getImage();
    $label = $this->getLabel();
    $description = $this->getDescription();

    if($description == null || $description == "")
      return "<IMG ALT=\"$label\" BORDER=\"0\" SRC=\"$image\">";
    else
      return "<A HREF=\"javascript: void 0\" onMouseOver=\"return top.code.info_mouseOver('$description')\" onMouseOut=\"return top.code.info_mouseOut();\"><IMG ALT=\"$label\" BORDER=\"0\" SRC=\"$image\"></A>";
  }
}