<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: Label.php,v 1.19.4.1 2001/11/06 21:30:08 jcheng Exp $

global $isLabelDefined;
if($isLabelDefined)
  return;
$isLabelDefined = true;

include("System.php");
include("uifc/HtmlComponent.php");

// also implements Collatable
class Label extends HtmlComponent {
  //
  // private variables
  //

  var $label;
  var $description;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this object lives in
  // param: label: a label string
  // param: description: a description string
  function Label(&$page, $label, $description = "") {
    // superclass constructor
    $this->HtmlComponent($page);

    $this->setLabel($label);
    $this->setDescription($description);
  }

  function getCollatableValue() {
    return $this->label;
  }

  function getDefaultStyle($stylist) {
    return $stylist->getStyle("Label");
  }

  // description: get the description of the label
  // returns: a string
  // see: setDescription()
  function getDescription() {
    return $this->description;
  }

  // description: set the description of the label
  // param: description: a string
  // see: getDescription()
  function setDescription($description) {
    $this->description = $description;
  }

  // description: get the label string of the label
  // returns: a string
  // see: setLabel()
  function getLabel() {
    return $this->label;
  }

  // description: set the label string of the label
  // param: label: a string
  // see: getLabel()
  function setLabel($label) {
    $this->label = $label;
  }

  function toHtml($style = "") {
    $page =& $this->getPage(); 
    global $_LABEL_ID; 
    $_LABEL_ID++;
    $id = $_LABEL_ID;

    // If a style object is passed in, use it,
    // otherwise use the style class variable
    // or the default style 
    $this->setRightStyle($style);    
    $style = $this->getStyle();

    // find out style properties
    $styleStr = $style->toBackgroundStyle($this->getStyleTarget()).$style->toTextStyle($this->getStyleTarget());
    $i18n =& $page->getI18n();

    // The HTML_ENTITIES translation table is only valid for the 
    // ISO-8859-1 character set. Japanese is the only supported 
    // language which does not use the ISO-8859-1 charset, so we 
    // do a special case for that.
    $encoding = $i18n->getProperty("encoding", "palette");
    if ($encoding == "none" || !strpos($encoding, "8859-1") === false ) {
      $specialChars = array_merge(get_html_translation_table(HTML_SPECIALCHARS), get_html_translation_table(HTML_ENTITIES));
      $label = strtr(strtr($this->getLabel(), array_flip($specialChars)), $specialChars);
    } else {
      $label = htmlspecialchars($this->getLabel());
    }
    // using interpolateJs this way is not very clean, but this works for now
    $description = $i18n->interpolateJs("[[VAR.string]]", array("string" => $this->getDescription()));

    if($description == null || $description == "")
      return "<FONT STYLE=\"$styleStr\">$label</FONT>"; 
    else {
      // log activity if necessary
      $logMouseOver = "";
      $logMouseOut = "";
      $logClick = "";
      $system = new System();
      if($system->getConfig("logPath") != "") {
	$logMouseOver = "top.code.uiLog_log('mouseOver', 'Label', '$label');";
	$logMouseOut = "top.code.uiLog_log('mouseOut', 'Label', '$label');";
	$logClick = "onClick=\"top.code.uiLog_log('click', 'Label', '$label');\"";
      }

      $javascript = "document._label_".$id."_description = '$description';"; 
      return "\n<SCRIPT language=\"javascript\">\n\t$javascript \n</SCRIPT>\n<A STYLE=\"$styleStr\" HREF=\"javascript: void 0\" onMouseOver=\"$logMouseOver return top.code.info_mouseOver(document._label_".$id."_description)\" onMouseOut=\"$logMouseOut return top.code.info_mouseOut();\" $logClick>$label</A>";
    }
  }
}
