<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: Password.php,v 1.18 2001/04/13 01:55:21 kevin Exp $

global $isPasswordDefined;
if($isPasswordDefined)
  return;
$isPasswordDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class Password extends FormField {
  //
  // private variables
  //

  var $isConfirm;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  // param: value: the default value
  // param: invalidMessage: message to be shown upon invalid input. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function Password(&$page, $id, $value, $invalidMessage, $emptyMessage = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, $invalidMessage, $emptyMessage);

    $this->isConfirm = true;
  }

  function &getDefaultStyle(&$stylist) {
    return $stylist->getStyle("Password");
  }

  // description: see if the confirm field is shown
  // returns: if true, a confirm field is shown
  // see: setConfirm()
  function isConfirm() {
    return $this->isConfirm;
  }

  // description: show/hide the confirm field
  // param: isConfirm: if true, a confirm field is shown
  // see: isConfirm()
  function setConfirm($isConfirm) {
    $this->isConfirm = $isConfirm;
  }

  function toHtml($style = "") {
    $id = $this->getId();
    $access = $this->getAccess();

    $builder = new FormFieldBuilder();
    $field1 = $builder->makePasswordField($id, $this->getValue(), 
	$access, $GLOBALS["_FormField_width"], "");

    // no need to make confirm field?
    if(!$this->isConfirm())
      return $field1;

    $page = $this->getPage();

    if($style == null || $style->getPropertyNumber() == 0)
      $style =& $this->getDefaultStyle($page->getStylist());

    // find out style properties
    $subscriptStyleStr = $style->toTextStyle("subscript");

    // make repeat field
    $repeatId = "_".$id."_repeat";
    $field2 = $builder->makePasswordField($repeatId, $this->getValue(), 
	$access, $GLOBALS["_FormField_width"], "");

    $i18n =& $page->getI18n();
    $repeatStr = $i18n->get("repeat", "palette");

    $formField = "
<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\">
  <TR><TD>$field1</TD></TR>
  <TR><TD NOWRAP>$field2 <FONT STYLE=\"$subscriptStyleStr\">($repeatStr)</FONT></TD></TR>
</TABLE>
";

    $formField .= $builder->makeJavaScript($this, "", "top.code.Password_submitHandler");

    $form =& $page->getForm();
    $formId = $form->getId();
    $formField .= "
<SCRIPT LANGUAGE=\"javascript\">
var element = document.$formId.$id;
element.repeatElement = document.$formId.$repeatId;
</SCRIPT>
";

    return $formField;
  }
}
