<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: TextBlock.php,v 1.13 2001/04/13 01:55:21 kevin Exp $

global $isTextBlockDefined;
if($isTextBlockDefined)
  return;
$isTextBlockDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class TextBlock extends FormField {
  //
  // private variables
  //

  var $height;
  var $width;
  var $wrap;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object that this object lives in
  // param: id: the identifier of the object
  // param: value: a text string. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function TextBlock(&$page, $id, $value = "", $emptyMessage = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, "", $emptyMessage);

    $this->height = $GLOBALS["_FormField_height"];
    $this->width = $GLOBALS["_FormField_width"];
    $this->wrap = false;
  }

  // description: get the height or number of rows
  // returns: an integer
  // see: setHeight()
  function getHeight() {
    return $this->height;
  }

  // description: set the height or number of rows
  // param: height: an integer
  // see: getHeight()
  function setHeight($height) {
    $this->height = $height;
  }

  // description: get the width of or number of columns
  // returns: an integer
  // see: setWidth()
  function getWidth() {
    return $this->width;
  }

  // description: set the width of or number of columns
  // param: width: an integer
  // see: getWidth()
  function setWidth($width) {
    $this->width = $width;
  }

  // description: set to/not to wrap text
  // param: val: true to wrap, false otherwise
  // see: isWrap()
  function setWrap($val = false) {
    $this->wrap = $val;
  }

  // description: see if text should be wrapped or not
  // returns: true to wrap, false otherwise
  // see: setWrap()
  function isWrap() {
    return $this->wrap;
  }

  function toHtml($style = "") {
    $builder = new FormFieldBuilder();
    $formField = $builder->makeTextAreaField($this->getId(), $this->getValue(), $this->getAccess(), $this->height, $this->width, "", $this->wrap ? "on" : "off");
    $formField .= $builder->makeJavaScript($this, "", $GLOBALS["_FormField_TextField_submit"]);

    return $formField;
  }
}
