<?php
// Author: Harris Vaegan-LLoyd
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: TextField.php,v 1.13 2001/06/01 04:36:16 ebraswell Exp $

global $isTextFieldDefined;
if($isTextFieldDefined)
  return;
$isTextFieldDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class TextField extends FormField {
  //
  // public methods
  //

  var $size, $maxLength;

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  // param: value: the default value
  // param: invalidMessage: message to be shown upon invalid input. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function TextField(&$page, $id, $value, $invalidMessage = "", $emptyMessage = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, $invalidMessage, $emptyMessage);

    $this->size = $GLOBALS["_FormField_width"];
    $this->maxLength = 0;
  }

  // Deprecated. Use setWidth
  function setSize($size) {
    $this->setWidth($size);
  }

  // description: set the size or number of columns
  // param: size: an integer
  function setWidth($size) {
        $this->size = $size;
  }

  // returns an integer representing the current width setting or number of columns
  function getWidth() {
        return($this->size);
  }

  // description: set the maximum length or characters the field can take
  // param: len: an integer
  function setMaxLength($len) {
    $this->maxLength = $len;
  }

  function toHtml($style = "") {
    $id = $this->getId();

    $builder = new FormFieldBuilder();
    $formField = $builder->makeTextField($id, $this->getValue(), $this->getAccess(), $this->size, $this->maxLength, $GLOBALS["_FormField_change"]);
    $formField .= $builder->makeJavaScript($this, "", $GLOBALS["_FormField_TextField_submit"]);

    return $formField;
  }
}