<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: Url.php,v 1.12 2001/08/03 01:09:44 jcheng Exp $

global $isUrlDefined;
if($isUrlDefined)
  return;
$isUrlDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class Url extends FormField {
  //
  // private variables
  //

  var $label;
  var $target;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  // param: value: the URL
  // param: label: a label in string. Optional
  // param: target: the TARGET attribute of the A tag. Optional
  // param: invalidMessage: message to be shown upon invalid input. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function Url(&$page, $id, $value, $label = "", $target = "", $invalidMessage = "", $emptyMessage = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, $invalidMessage, $emptyMessage);

    // we would normally need to add data preservation for targets 
    // and labels. But those are only used in a read-only state
    // and there is no changed data to preserve in a read-only state,
    // so we don't need to do anything
    $this->setLabel($label);
    $this->setTarget($target);
  }

  function getCollatableValue() {
    $label = $this->getLabel();
    return ($label != "") ? $label : $this->getValue();
  }

  // description: get the label
  // returns: a label in string
  // see: setLabel()
  function getLabel() {
    return $this->label;
  }

  // description: set the label
  // param: label: a label in string
  // see: getLabel()
  function setLabel($label) {
    $this->label = $label;
  }

  // description: get the target
  // returns: the TARGET attribute of the A tag
  // see: setTarget()
  function getTarget() {
    return $this->target;
  }

  // description: set the target
  // param: target: the TARGET attribute of the A tag
  // see: getTarget()
  function setTarget($target) {
    $this->target = $target;
  }

  function toHtml($style = "") {
    $access = $this->getAccess();
    $id = $this->getId();
    $value = $this->getValue();

    if($access == "r") {
      $label = $this->getLabel();
      $target = $this->getTarget();

      if($label == "")
	$label = $value;

      if($target != "")
	$target = "TARGET=\"$target\"";

      // HTML safe
      $label = htmlspecialchars($label);

      return "<A HREF=\"$value\" $target>$label</A>";
    }
    else {
      $builder = new FormFieldBuilder();
      $formField .= $builder->makeTextField($id, $value, $access, $GLOBALS["_FormField_width_big"], "", $GLOBALS["_FormField_change"]);
      $formField .= $builder->makeJavaScript($this, "top.code.Url_changeHandler", $GLOBALS["_FormField_TextField_submit"]);

      return $formField;
    }
  }
}
