<?
/**
  * Utility Library for Page Functions
  *
  * These functions are intended to output standard pages or page elements. 
  * They are designed to be small and fast and use procedural code for speed.
  *
  * $Id: page.php,v 1.1.2.1 2001/12/06 02:04:47 jcheng Exp $
  *
  * @author  Eric Braswell
  * @version $Revision: 1.1.2.1 $
  * @copyright  Copyright 2001 Sun Microsystems, Inc. All Rights Reserved.
  * @access public
  */  

/**
 * Print out a basic page with appropriate options
 *
 * @param string $onLoad    Javascript to call when page loads
 * @param string $body        Contents of the body portion of the page
 * @param string $head        Extra stuff to put in the head portion
 */
function page_printBasic($onLoad="", $body="", $head="") {
    if(!empty($onLoad)) {
        $onLoad = sprintf("onLoad=\"%s\"", $onLoad);        
    }
    if (!headers_sent()) {
        header("cache-control: no-cache");    
    }
    ?>
    <HTML>
        <HEAD>
            <META HTTP-EQUIV=\"expires\" CONTENT=\"-1\">
            <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
            <? print($head); ?>
        </HEAD>
        <BODY <? print($onLoad); ?>>
           <? print($body); ?>
        </BODY>
        <HEAD> <!-- convince IE really not to cache -->
            <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
        </HEAD>
    </HTML>
    <?  
}


?>