<?php
// Author: Mike Waychison, Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: MultiFileUpload.php,v 1.7 2000/12/01 04:54:39 kevin Exp $

include("ServerScriptHelper.php");
$serverScriptHelper = new ServerScriptHelper();

$product = $serverScriptHelper->getProductCode();
$isMonterey = ereg("35[0-9][0-9]R", $product);

// find form action depending on product
if ((!$isMonterey) && $serverScriptHelper->hasCCE())
  $formAction = "MultiFileUploadHandler.php";
else
  $formAction = "/base/webmail/MultiFileUploadHandler.php";

$factory = $serverScriptHelper->getHtmlComponentFactory("palette", $formAction);

$page = $factory->getPage();
$form = $page->getForm();
$formId = $form->getId();

$block = $factory->getPagedBlock("addAttachment");

$fileUpload = $factory->getFileUpload("fileUpload", "", 3);
$block->addFormField ($fileUpload, $factory->getLabel("fileToAttach"));

// we need a separate field to pass file name because the $fileUpload_name
// variable that PHP produce is wrong if the file name contains 0x5C characters
$block->addFormField ($factory->getTextField("fileUpload_name", "", ""));

$block->addButton($factory->getButton("javascript: upload()", "addAttachmentButton"));
$block->addButton($factory->getCancelButton("javascript: top.close()"));

/* print the page */
print $page->toHeaderHtml();
?>

<SCRIPT LANGUAGE="javascript">
function upload() {
  var form = document.<?php print($formId); ?>;
  var fileName = form.fileUpload.value;

  var appName = navigator.appName;
  var appVersion = navigator.appVersion;

  // NN on Mac URL encode the file name. so we need to decode it
  if(appName.indexOf("Netscape") != -1 && appVersion.indexOf("Mac") != -1)
    fileName = unescape(fileName);

  // find out file delimiter
  // Mac is "/" as well
  var delimiter = "/";
  if(appVersion.indexOf("Win") != -1)
    delimiter = "\\";

  // figure out the base name of the file
  var baseName = fileName.substring(fileName.lastIndexOf(delimiter)+1);

  // use form field to pass file name
  form.fileUpload_name.value = baseName;

  form.submit();
}
</SCRIPT>

<?php print $block->toHtml(); ?>

<SCRIPT LANGUAGE="javascript">
/* change the Max File Size to reflect the actual upload size */
document.<?php print $formId ?>.MAX_FILE_SIZE.value = top.maxFileSize;
</SCRIPT>

<?php print $page->toFooterHtml(); ?>